{% extends "base.j2" %}
{% block init_code %}
#!/usr/bin/env python

# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 3
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; If not, see <http://www.gnu.org/licenses/>.
#
# Copyright 2021 CELLS / ALBA Synchrotron, Cerdanyola del Valles, Spain
#
# ##### END GPL LICENSE BLOCK #####


from about import monkey_patch_about_action
from constants import version
from panel import DllrfPanel
import pathlib
from taurus import tauruscustomsettings
from taurus.qt.qtgui.application import TaurusApplication
from taurus_pyqtgraph import TaurusTrend
from taurus.qt.qtgui.taurusgui import TaurusGui


def main():
    app_name = f"Digital Low Level Radio Frequency"
    app = TaurusApplication(
            cmd_line_parser=None,
            app_name=app_name,
            app_version=version,
            org_name='Alba'
    )
    tauruscustomsettings.ORGANIZATION_LOGO = \
        f"{pathlib.Path(__file__).parent.absolute()}/imgs/alba_logo.jpg"
    gui = TaurusGui(confname=f"{pathlib.Path(__file__).parent.absolute()}/"
                             f"Digital Low Level Radio Frequency.py")
    monkey_patch_about_action(gui,
                              csv_version='{{csv_version}}',
                              codegen_version='{{codegen_version}}',
                              device_name='{{device}}')
    panels = {
{% endblock %}

{% block settings_attributes %}{% endblock %}

{% block diags_attributes %}{% endblock %}

{% block dc_attributes %}{% endblock %}

{% block tunning_attributes %}{% endblock %}

{% block vcxo_attributes %}{% endblock %}

{% block diag_matrix_attributes %}{% endblock %}

{% block end_code %}
    }
    for panel_name in panels:
        panel = DllrfPanel(withButtons=False)
        panel.setModel(panels[panel_name])
        gui.createPanel(panel, panel_name)
    panel = TaurusTrend()
    gui.createPanel(panel, "Trend")
    if 'default' in gui.getPerspectivesList():
        gui.loadPerspective(name='default')
    gui.show()
    app.exec_()


if __name__ == '__main__':
    main()

{% endblock %}